################################################################################
################################################################################
################################################################################

''' ATTENZIONE!!! INSERITE QUI SOTTO IL VOSTRO NOME, COGNOME E MATRICOLA '''

nome        = "NOME"
cognome     = "COGNOME"
matricola   = "MATRICOLA"

################################################################################
################################################################################
################################################################################

'''
    Es 10: 3 punti
Abbiamo una lista  di quadruple di interi. 
Ciascuna quadrupla (x1,y1,x2,y2) individua un rettangolo nel piano con lati 
perpendicolari agli assi. I primi due interi sono  l'ascisse e l'ordinata del vertice 
del rettangolo in altro a sinistra e gli ultimi due sono l'ascisse e l'ordinata del 
vertice in basso a sinistra. 
Data una quadrupla R rappresentante un rettangolo e la lista con le quadruple di 
rettangoli,  vogliamo sapere quali rettangoli della lista intersecano il rettangolo R.

Progettare una funzione es10(R, lista) che prende come parametri la quadrupla del rettangolo 
R e la lista con le quadruple degli altri rettangoli e restituisce un insieme 
contente le posizioni della lista in cui  compaiono rettangoli che intersecano con R.

Ad esempio per R= (2,4,6,2) e lista1=[(3,6,5,1),(6,6,7,5),(1,8,8,1)] la funzione 
deve restituire l'insieme {0,2}

'''

def es10(R, lista):
    ret=set()
    for i in range(len(lista)):
        x3,y3,x4,y4=lista[i]
        if interseca(R,lista[i]): ret.add(i)
    return ret

def interseca(R,R1):
    x1,y1,x2,y2=R
    x3,y3,x4,y4=R1
    if x1<=x4<=x2 or x1<=x3<=x2 or x3<=x2<=x4 or x3<=x1<=x4:
        if y2<=y3<=y1 or y2<=y4<=y1 or y4<=y1<=y3 or y4<=y2<=y3: return True
    return False


################################################################################

'''
Es 1: 3 punti

Una terna pitagorica e' un insieme di tre interi x,y,z tali che x**2+y**2=z**2.

Si definisca  la funzione es1(lis) che, riceve come argomento una lista lis 
di interi distinti e cerca in lis eventuali terne pitagoriche. 
La funzione deve restituire una lista contenente tutte le terne pitagoriche 
presenti in lis.
Ciascuna terna pitagorica  deve essere rappresentata tramite tupla, 
in ciascuna tupla  le coordinate devono avere valori crescenti e le tuple nella lista 
devono comparire in ordine crescente. 

Ad esempio:
es1([7,4,3,25,5,2,12,24,13,14]) deve restituire la lista:
[(3,4,5),(5,12,13),(7,24,25)]
'''


def es1(lis):
    lis.sort()
    lista=[]
    for i in range(len(lis)-2):
        for j in range(i,len(lis)-1):
            for k in range(j+1,len(lis)):
                if lis[i]**2+lis[j]**2==lis[k]**2:
                    lista.append((lis[i],lis[j],lis[k]))
    return lista

#####################################################################################

'''
Es 4: 3 punti.

Un file contiene una sequenza  di uguaglianze tra somme di interi positivi,
un'uguaglianza  per riga, ciascuna terminata da un punto e virgola, e senza spazi. 

Come esempio, si consideri il  file f4a.txt contenente le 4 righe:

2+3+12=9+8;
2+3+4=9;
22=3+4+5+10;
3+5+1=4+44;

Si noti che le uguaglianze possono essere sia corrette (le prime tre) che 
sbagliate (l’ultima).

Si progetti una funzione es4(ftesto) che riceve come argomento  l'indirizzo 
del file contenente la sequenza di uguaglianze e restituisce 
il numero di uguaglianze corrette presenti nel file. 

Per il file dell'esempio la funzione deve restituire il numero 3. 
'''

def es4(ftesto):
    with open(ftesto, encoding='utf8') as f:
        lista=f.read().split()
    corrette=0
    for s in lista:
        s1=s[:-1]
        lista1=s1.split('=')
        a=sum([int(x) for x in lista1[0].split('+')])
        b=sum([int(x) for x in lista1[1].split('+')])
        if a==b: corrette+=1
    return corrette




######################################################################################

import immagini

'''    
    Es 5: 3 punti
    Progettare la  funzione es5(fimm) che prende come parametro 
    l'indirizzo di un file .PNG e restituisce una tupla.
    La tupla e' una coppia di interi. L'intero nella prima coordinata e' 
    l'indice della colonna dell' immagine in cui compaiono il numero massimo 
    di colori distinti. L'intero nella seconda coordinata e' l'indice della riga 
    dell'immagine in cui compaiono il numero massimo di colori distinti.
    A parita' di numero massimo di colori viene scelta la colonna o la riga  
    di indice minimo.
    Ad esempio per la foto f5a.png (di 30 colonne e 20 righe ) la funzione 
    restituira' la coppia (20,10)
    
    Per caricare e salvare i file PNG si possono usare load e 
    save della libreria immagini.
    '''

def es5(fimm):
    img = immagini.load(fimm)
    w, h = len(img[0]), len(img)
    massimo_c=0
    for c in range(w):
        a=colori_colonna(img,c)
        if a>massimo_c:
            colonna=c
            massimo_c=a
    massimo_r=0
    for r in range(h):
        a=colori_riga(img,r)
        if a>massimo_r:
            riga=r
            massimo_r=a
    return (colonna,riga)       
    
def colori_colonna(img,c):
    ins=set()
    for i in range(len(img)):
        ins.add(img[i][c])
    return len(ins)

def colori_riga(img,r):
    ins=set()
    for j in range(len(img[0])):
        ins.add(img[r][j])
    return len(ins)

############################################################################

import albero

'''
    Es 100: 3 punti
    Si definisca la funzione es100(tree) ricorsiva (o che fa uso 
    di funzioni o metodi ricorsive/i) che riceve come parametro la radice di un albero 
    formato da nodi del tipo Nodo definito nella libreria albero.py allegata, 
    torna come risultato la lista degli identificativi dei nodi dell'albero. 
    La lista deve risultare ordinata in modo crescente.

    
    Esempio:  la funzione es100
    - sull'albero a sinistra restituisce  [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 20] 
    - sull'albero a destra restituisce [0, 1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 13, 15].


              5                                     7              
      ________|_____________                _______|______         
     |          |           |              |              |        
     20         4           6              5              9        
     |     _____|______                 ___|___        ___|__      
     11   |   |  |  |  |               |       |      |      |     
          10  2  9  8  7               10      8      3      1     
            __|__                     _|_     _|_    _|_    _|_    
           |     |                   |   |   |   |  |   |  |   |   
           3     1                   1   2   12  13 15  6  4   0   
                                                                   
    '''

def es100(tree):
    # inserisci qui il tuo codice
    return sorted(es1b(tree))
    
def es1b(tree):
    # inserisci qui il tuo codice
    lista=[tree.id]
    for x in tree.f:
        lista=lista + es1b(x)
    return lista 


###########################################################################

import albero

'''
    Es 101: 3 punti

    Si definisca la funzione es101(tree) ricorsiva (o che fa uso 
    di funzioni o metodi ricorsive/i) che riceve come parametro la radice di un albero 
    formato da nodi del tipo Nodo definito nella libreria albero.py allegata e 
    torna come risultato una lista.
    La lista contiene tuple, una tupla per ogni livello dell'albero, 
    la tupla  contiene in ordine crescente gli identificatori dei nodi 
    che si trovano ad uno stesso livello.
    Nella lista le tuple devono risultare ordinate per numero di coordinate crescente 
    e, a parita' di coordinate, in ordine lessicografico crescente.
        
    Esempio:  la funzione es101
    - sull'albero a sinistra restituisce [(5,), (22, 30), (4, 6, 20), (2, 7, 8, 9, 10, 12)]
    - sull'albero a destra restituisce [(5,),(4,20),(1,2,7,9)].

              5                                    5                    
      ________|_____________               ________|_                   
     |          |           |             |          |                  
     20         4           6             20         4                  
     |     _____|______                   |       ___|___               
     12   |   |  |  |  |                  1      |   |   |              
          10  2  9  8  7                         2   9   7              
            __|__                                                       
           |     |                                                      
           30    22                                                     
                                                                        
    '''

def es101(tree):
    d=es101b(tree)
    lista=[]
    for x in d:
        lista.append(tuple(sorted(d[x])))
    return sorted(lista, key=lambda x: (len(x),x))
    
def es101b(tree,k=0):
    d={}
    # produce un dizionario con chiave i livelli dell'albero e attributo l'insieme di identificatori
    #dei nodi presenti a quel livello
    for x in tree.f:
        d1=es101b(x,k+1)
        for x in d1:
            if x in d: 
                d[x]=d[x] | d1[x]
            else:
                d[x]=d1[x]
    d[k]=  {tree.id}        
    return d 



